// Example Reason file

let pi = 3.14159;

/*
 * computing mod
 */

let remainder = (x, y) => {
    x mod y;
};

// pi * r * r
let circle_area = (radius: float) => {
    pi *. radius *. radius;
};

// add two points
// p1 => (x1, y1)
// p2 => (x2, y2)
let add_points = (p1, p2) => {
    // tuple decomposition
    let (x1, y1) = p1;
    let (x2, y2) = p2;
    (x1 + x2, y1 + y2); 
};

let add_points_decompose = ((x1, y1), (x2, y2)) => 
    (x1 + x2, y1 + y2);

let rec add_element2 = (set: list('a), e: 'a) => {
    if (set == []) {
        [e];
    } else {
        if (List.hd(set) == e) {
            set;
        } else {
            [List.hd(set), ...add_element2(List.tl(set), e)];
        }
    }
};

let rec add_element = (set: list('a), e: 'a) => {
    switch(set) {
        | [] => [e]
        | [hd, ..._] when e == hd => set
        | [hd, ...tl] => [hd, ...add_element(tl, e)]
    };
};

let rec factorial = (a : int) => {
    if (a < 0) {
        failwith("cannot compute factorials of negative numbers");
    };
    if (a == 0) {
        1
    } else {
        a * factorial(a-1)
    }
};